Skip to main content
cancel
Showing results for 
Search instead for 
Did you mean: 

Learn from the best! Meet the four finalists headed to the FINALS of the Power BI Dataviz World Championships! Register now

Reply
Anonymous
Not applicable

Set AzureBlob Datasource key using REST API

Hi,

 

I have a report which I embedded to my application using pbie.

the report itself have been embedded successfully, but the dataset cannot be refreshed.

after some checking, I know that the dataset doesn't have enough credentials to access my datasource, which are a csv file in Azure Blob storage.

Now, if I manually add my azure blob credentials to my datasets from power bi workspace it could be refreshed.

But, I want to automatically set my credentials from my application which are written in javascript.

 

I tried to use this API first to get my gateway and Datasource ID

 

GET https://api.powerbi.com/v1.0/myorg/datasets/{datasetId}/datasources

 

 it went well and I got the information perfectly.

 

next step, I wanted to update my datasource credentials information using this API

 

PATCH https://api.powerbi.com/v1.0/myorg/gateways/{gatewayId}/datasources/{datasourceId}

 

 with my OAuth token as my Authentication header, and request body like below:

 

{
	"credentialDetails": {
		"credentialType": "Key",
		"credentials": "{\"credentialData\":[{\"name\":\"key\", \"value\":\"MY KEY\"}]}",
		"encryptedConnection": "Encrypted",
		"encryptionAlgorithm": "None",
		"privacyLevel": "None"
	}
}

 

 

but it gave my 401 error with response :

 

{
  "error": {
    "code": "PowerBINotAuthorizedException",
    "pbi.error": {
      "code": "PowerBINotAuthorizedException",
      "parameters": {},
      "details": [],
      "exceptionCulprit": 1
    }
  }
}

 

 

can anybody give me a hint for where I done wrong?

or maybe if there are any other way to do this I would appriciate the infromation

 

bests,

2 REPLIES 2
asarraf21
Frequent Visitor

I am having the same issue, it is reported elsewhere too.

I think the core of the issue is that the PATCH endpoint does not work. My usecase was a BASIC user/pass to update datasource for Azure SQL server and it is throwing the same exception. This is my payload:

 

{
  "credentialDetails": {
    "credentialType": "Basic",
    "credentials": "{\"credentialData\":[{\"name\":\"username\", \"value\":\"admin\"},{\"name\":\"password\", \"value\":\"S3cretPasswrd\"}]}",
    "encryptedConnection": "Encrypted",
    "encryptionAlgorithm": "None",
    "privacyLevel": "Private"
  }
}

 

The challenge is the exact same payload and endpoint works fine when you are logged in and run it interactively in the REST page. But when you get the token all through the REST api it throws an exception.

duartte23
New Member

Hi,

 

Did you get an answer to this issue?

Helpful resources

Announcements
Power BI DataViz World Championships carousel

Power BI DataViz World Championships - June 2026

A new Power BI DataViz World Championship is coming this June! Don't miss out on submitting your entry.

Join our Fabric User Panel

Join our Fabric User Panel

Share feedback directly with Fabric product managers, participate in targeted research studies and influence the Fabric roadmap.

March Power BI Update Carousel

Power BI Community Update - March 2026

Check out the March 2026 Power BI update to learn about new features.